.intel_syntax noprefix

.text

.global najcesca_cifra

# int najcesca_cifra(unsigned n)
# eax                edi
najcesca_cifra:
    enter 40, 0     # zauzimamo 40B

    # cesto prilikom zauzimanja memorije zauzimamo broj bajtova
    # deljiv sa 16 (npr u ovom slucaju bi onda zauzeli 48)
    # ukoliko pozivamo druge funkcije time olaksavamo poravnavanje
    # steka prilikom poziva. 
    
    # Postoje 2 nacina na koji to mozemo da uradim:
    #     1) rucno (samo napisemo broj deljiv sa 16)
    #     2) "pametno":
    #            nakon enter 40, 0 dodamo  and rsp, -16
    #               -16 binarno ima sve jedinice osim prve 4 nule
    #               kako je broj deljiv sa 16 akko su mu u binarnom
    #               zapisu prve 4 cifre 0, ovo ce "naterati" registar
    #               rsp da bude deljiv sa 16. Takodje se ovako dobija
    #               prvi broj manji od rsp koji je deljiv sa 16 tako da
    #               ne trosimo neku memoriju uzalud.
    

    lea r8, [rbp-40]     # r8 - brojaci

    # Popunjavanje niza brojaca nulama
    # for(i=0; i<10; i++) brojaci[i] = 0
    mov ecx, 0
init_petlja:
    cmp ecx, 10
    je init_petlja_kraj

        mov dword ptr [r8+4*rcx], 0

    inc ecx
    jmp init_petlja
init_petlja_kraj:


    # Prebrojavanje koliko se puta koja cifra pojavljuje
    # do {brojaci[n%10]++; n /= 10;} while(n != 0)
prebroj_cifre:

        mov esi, 10
        mov eax, edi
        xor edx, edx
        div esi          # eax = n / 10 edx = n % 10
        
        add dword ptr [r8+4*rdx], 1  # brojaci[n%10]++

        mov edi, eax      # n = n / 10

    cmp edi, 0
    jne prebroj_cifre


    # trazenje cifre koja se pojavljuje najveci broj puta
    # max_c = 0, max_bp = 0; for(i=0; i<10; i++){if(brojaci[i] > max_bp) {azuriramo stvari}}

    # inicijalizacija pocetnih "maksimuma"
    mov r9d, 0           # r9d - max_c
    mov r10d, -1          # r10d - max_bp

    # for petlja
    mov ecx, 0
petlja_max:
    cmp ecx, 10
    je petlja_max_kraj

        mov eax, [r8+4*rcx]
        cmp eax, r10d
        jle manje_ili_jednako  # provera da li smo naisli na cescu cifru
            mov r10d, eax      # azuriranje promenjivih
            mov r9d, ecx
    manje_ili_jednako:

    inc ecx
    jmp petlja_max
petlja_max_kraj:

    mov eax, r9d
    leave
    ret

